com.r3corda.node.internal / ServerRPCOps

# ServerRPCOps

`class ServerRPCOps : CordaRPCOps`

Server side implementations of RPCs available to MQ based client tools. Execution takes place on the server thread (i.e. serially). Arguments are serialised and deserialised automatically.

### Exceptions

InputStateRefResolveFailed | `class InputStateRefResolveFailed : Exception`

### Constructors

<init> | `ServerRPCOps(services: ServiceHub, smm: StateMachineManager, database: <ERROR CLASS>)` Server side implementations of RPCs available to MQ based client tools. Execution takes place on the server thread (i.e. serially). Arguments are serialised and deserialised automatically.

### Properties

database | `val database: <ERROR CLASS>`
protocolVersion | `val protocolVersion: Int` Returns the RPC protocol version. Exists since version 0 so guaranteed to be present.
services | `val services: ServiceHub`
smm | `val smm: StateMachineManager`

### Functions

executeCommand | `fun executeCommand(command: ClientToServiceCommand): TransactionBuildResult` Executes the given command, possibly triggering cash creation etc. TODO: The signature of this is weird because its the remains of an old service call, we should have a call for each command instead.
stateMachineRecordedTransactionMapping | `fun stateMachineRecordedTransactionMapping(): <ERROR CLASS><List<StateMachineTransactionMapping>, <ERROR CLASS><StateMachineTransactionMapping>>` Returns a snapshot list of existing state machine id - recorded transaction hash mappings, and a stream of future such mappings as well.
stateMachinesAndUpdates | `fun stateMachinesAndUpdates(): <ERROR CLASS><List<StateMachineInfo>, <ERROR CLASS><StateMachineUpdate>>` Returns a pair of currently in-progress state machine infos and an observable of future state machine adds/removes.
vaultAndUpdates | `fun vaultAndUpdates(): <ERROR CLASS><List<StateAndRef<ContractState>>, <ERROR CLASS><Update>>` Returns a pair of head states in the vault and an observable of future updates to the vault.
verifiedTransactions | `fun verifiedTransactions(): <ERROR CLASS><List<SignedTransaction>, <ERROR CLASS><SignedTransaction>>` Returns a pair of all recorded transactions and an observable of future recorded ones.